import java.awt.*;
import java.awt.event.*;
import java.awt.print.*;
import javax.swing.*;
import java.util.Vector;
import java.io.*;
    
public class Paint extends JFrame{

     Container javaPaint;	//Fentre principale
     Dessin unDessin;		//Cadre de Dessin
     fen Ap;				//Fentre  Propos
     palette pl;			//Palette de Couleur
     
     
     
     
	 //////////////////// Panneau d'outils et de couleurs ////////////////////
	 JPanel panneau			=new JPanel(new GridLayout(1,3));	//Ensemble
     JPanel panneauCouleur	=new JPanel(new GridLayout(2,8));	//Outils
     JPanel panneauOutil	=new JPanel(new GridLayout(2,5));	//Couleurs
     /////////////////////////////////////////////////////////////////////////
     
     
     
     
     //////////////////// Label ////////////////////
     JLabel labelLogo		=new JLabel();	//Logo
     ///////////////////////////////////////////////




     //////////////////// Barre de Menu ////////////////////
     MenuBar mb				=new MenuBar();	//Menu Barre
     ///////////////////////////////////////////////////////
     
     
     
     
     //////////////////// Choix au Menu ////////////////////
     Menu Fich				=new Menu("Fichier");	//Fichier du Menu
     Menu Apropos			=new Menu("A Propos");	//A Propos du Menu
     ///////////////////////////////////////////////////////
     
     
     
     
     //////////////////// Choix au Sous-Menu ////////////////////
     //Fichier
     MenuItem New			=new MenuItem("New");
     MenuItem Ouvrir		=new MenuItem("Ouvrir");
     MenuItem Enregistrer	=new MenuItem("Enregistrer");
     MenuItem Fermer		=new MenuItem("Quitter");
     //A Propos
     MenuItem Auteurs 		=new MenuItem("Auteurs");
     //Choix
     Choice vp				=new Choice();
     ////////////////////////////////////////////////////////////
     
     
     
     
	 //////////////////// Icnes ////////////////////
	 ImageIcon imageCrayon	=new ImageIcon("images/crayon.gif");
	 ImageIcon imageLigne	=new ImageIcon("images/ligne.gif");
	 ImageIcon imageOval	=new ImageIcon("images/oval.gif");
	 ImageIcon imagePinceau	=new ImageIcon("images/pinceau.gif");
	 ImageIcon imageRectArr	=new ImageIcon("images/rectangle_arrondi.gif");
	 ImageIcon imageRect	=new ImageIcon("images/rectangle.gif");
	 ImageIcon imageArc		=new ImageIcon("images/arc.gif");
	 ImageIcon imageEfface	=new ImageIcon("images/efface.gif");
	 ImageIcon imagePipette	=new ImageIcon("images/pipette.gif");
	 ImageIcon imageTexte	=new ImageIcon("images/texte.gif");
	 ImageIcon imageLogo	=new ImageIcon("images/logo.gif");
	 ImageIcon imagePalette	=new ImageIcon("images/palette.gif");
	 ////////////////////////////////////////////////
	 
	 
	 
	 
	 //////////////////// Boutons ////////////////////
	 //Outils
	 JButton crayon		=new JButton(imageCrayon);
	 JButton ligne		=new JButton(imageLigne);
	 JButton oval		=new JButton(imageOval);
	 JButton pinceau	=new JButton(imagePinceau);
	 JButton rectarr	=new JButton(imageRectArr);
	 JButton rect		=new JButton(imageRect);
	 JButton arc		=new JButton(imageArc);
	 JButton efface		=new JButton(imageEfface);
	 JButton pipette	=new JButton(imagePipette);
	 JButton texte		=new JButton(imageTexte);
	 //Couleurs
	 JButton noir		=new JButton();
     JButton rouge		=new JButton();
     JButton vert		=new JButton();
     JButton bleu		=new JButton();
     JButton jaune		=new JButton();
     JButton rose		=new JButton();
     JButton magenta	=new JButton();
     JButton orange		=new JButton();
	 //Palette
	 JButton palett		=new JButton(imagePalette);
	 /////////////////////////////////////////////////
	 
	 
	 
	 
	 //////////////////// Dimenssion ////////////////////
	 Dimension dimBouton	=new Dimension(20,20);
	 Dimension dimPanneau	=new Dimension(500,40);
	 Dimension dimVide		=new Dimension(240,40);
	 Dimension dimOutil		=new Dimension(100,40);
	 Dimension dimCouleur	=new Dimension(160,40);
     ////////////////////////////////////////////////////
     
     
     
     
//Le constructeur:

     public Paint(){
        super			("JaVa Paint!");		//Titre
        unDessin		=new Dessin();			//Le dessin
        pl				=new palette(unDessin);	//Palette de Couleur
        Ap				=new fen();				//Fentre  Propos
        
        
        
        
        //////////////////// Conteneur Principal ////////////////////
        javaPaint		=getContentPane();
        /////////////////////////////////////////////////////////////
        
        
        
        
        //////////////////// LAYOUT ////////////////////
        javaPaint		.setLayout(new FlowLayout());
        ////////////////////////////////////////////////
        
        
        
        
        //////////////////// DIMENSSION ////////////////////
        rect			.setPreferredSize(dimBouton);
        rectarr			.setPreferredSize(dimBouton);
        ligne			.setPreferredSize(dimBouton);
        oval			.setPreferredSize(dimBouton);
        crayon			.setPreferredSize(dimBouton);
        arc				.setPreferredSize(dimBouton);
        efface			.setPreferredSize(dimBouton);
        pipette			.setPreferredSize(dimBouton);
        texte			.setPreferredSize(dimBouton);
        pinceau			.setPreferredSize(dimBouton);
        panneau			.setPreferredSize(dimPanneau);
        labelLogo		.setPreferredSize(dimVide);
        panneauOutil	.setPreferredSize(dimOutil);
        panneauCouleur	.setPreferredSize(dimCouleur);
        ////////////////////////////////////////////////////
        
        
        
        
        //////////////////// COUTEURS ////////////////////
        
        	//Menu Choix
        	Fermer	.addActionListener(new Fermer());
        	New		.addActionListener(new New());
        	
        	//Liste Choix
        	vp		.addItemListener(new videplein());
        	
        	// Boutons //
        	//Couleurs
			orange	.addActionListener(new orange());
        	noir	.addActionListener(new noir());
        	rouge	.addActionListener(new rouge());
       		vert	.addActionListener(new vert());
        	bleu	.addActionListener(new bleu());
        	jaune	.addActionListener(new jaune());
        	rose	.addActionListener(new rose());
        	magenta	.addActionListener(new magenta());
        	
        	//Palette
        	palett	.addActionListener(new Palett());
        	
        	//Outils
        	rect	.addActionListener(new rect());
        	rectarr	.addActionListener(new rectarr());
        	ligne	.addActionListener(new ligne());
        	oval	.addActionListener(new oval());
        	crayon	.addActionListener(new crayon());
        	arc		.addActionListener(new arc());
        	efface	.addActionListener(new efface());
        	pipette	.addActionListener(new pipette());
        	texte	.addActionListener(new texte());
        	pinceau	.addActionListener(new pinceau());
        	
        	// Propos
        	Auteurs	.addActionListener(new auteurs());
        ///////////////////////////////////////////////
        
        
        
        
		//////////////////// AJOUT ////////////////////
		
		//Choix
		vp.addItem("VIDE");
        vp.addItem("PLEIN");
        
		// Boutons //
        //Couleur
        panneauCouleur.add(orange);
        panneauCouleur.add(noir);
        panneauCouleur.add(rouge);
        panneauCouleur.add(vert);
        panneauCouleur.add(bleu);
        panneauCouleur.add(jaune);
        panneauCouleur.add(rose);
        panneauCouleur.add(magenta);
        panneauCouleur.add(vp);
        panneauCouleur.add(palett);

		//Outil
        panneauOutil.add(crayon);
        panneauOutil.add(pinceau);
        panneauOutil.add(oval);
        panneauOutil.add(ligne);
        panneauOutil.add(rectarr);
        panneauOutil.add(rect);
        panneauOutil.add(arc);
        panneauOutil.add(efface);
        panneauOutil.add(pipette);
        panneauOutil.add(texte);
        
        //Panneau
        panneau.add(panneauOutil);
        panneau.add(labelLogo);
        panneau.add(panneauCouleur);

		//Fichier
        Fich.add(New);
        Fich.add(Ouvrir);
        Fich.add(Enregistrer);
        Fich.addSeparator();
        Fich.add(Fermer);

		// Propos
        Apropos.add(Auteurs);
        
        //Menu
        mb.add(Fich);
        mb.add(Apropos);
        
        //Java Paint
        javaPaint.add(unDessin);
        javaPaint.add(panneau);
        ///////////////////////////////////////////////
        
        
        
        
        //////////////////// COULEUR DE FOND ////////////////////
        
        //Fentre principale
        javaPaint	.setBackground(Color.white);
        
		//Couleur du choix (VIDE / PLEIN)
        vp		.setBackground(	Color.white);
        
		// Couleur des boutons //
		//Pallette de Couleur
		orange	.setBackground(	Color.orange);
        noir	.setBackground(	Color.black);
        rouge	.setBackground(	Color.red);
        vert	.setBackground(	Color.green);
        bleu	.setBackground(	Color.blue);
        jaune	.setBackground(	Color.yellow);
        rose	.setBackground(	Color.pink);
        magenta	.setBackground(	Color.magenta);
        
        //Table d'outils
        crayon	.setBackground(	Color.white);
        ligne	.setBackground(	Color.white);
	 	oval	.setBackground(	Color.white);
	 	pinceau	.setBackground(	Color.white);
	 	rectarr	.setBackground(	Color.white);
	 	rect	.setBackground(	Color.white);
	 	arc		.setBackground(	Color.white);
	 	efface	.setBackground(	Color.white);
	 	pipette	.setBackground(	Color.white);
	 	texte	.setBackground(	Color.white);
	 	
	 	palett	.setBackground(	Color.red);
	 	
	 	//Panneau
	 	panneauOutil.setBackground(Color.white);
	 	panneauCouleur.setBackground(Color.white);
	 	/////////////////////////////////////////////////////////
	 	
	 	
	 	
	 	
	 	//////////////////// Configuration ////////////////////
	 	setMenuBar(mb);					//Le Menu Barre est...
	 	labelLogo.setIcon(imageLogo);	//Placer le logo
	 	///////////////////////////////////////////////////////
	 	
	 	
	 	
	 	
	 	Ouvrir.addActionListener(
			new ActionListener(){
				public void actionPerformed(ActionEvent evenement){
		try{
    		
    		//Cration d'un flux d'octets
			FileInputStream unfluxDEntree = new FileInputStream("Dessin.jvp");
			
			//On associe un filtre au flux
			ObjectInputStream unfiltreDEntree = new ObjectInputStream(unfluxDEntree);
			
			//On lit un objet dans le fichier par le filtre
			unDessin=	(Dessin)unfiltreDEntree.readObject();
			
			//On ferme
			unfiltreDEntree.close();
				
		}
		
		//Ce catch est obligatoire et doit etre place devant le catch IOException
		catch(ClassNotFoundException e){System.out.println(e.getMessage());}
		// Ce catch est lui aussi obligatoire
		catch(IOException e){System.out.println(e.getMessage());}
				}
			}
		);

		Enregistrer.addActionListener(
			new ActionListener(){
				public void actionPerformed(ActionEvent evenement){
			try{
			
			//Cration d'un flux d'octets
			FileOutputStream unfluxDeSortie = new FileOutputStream("Dessin.jvp");
			
			//On associe un filtre au flux
			ObjectOutputStream unFiltreDeRegularisation = new ObjectOutputStream(unfluxDeSortie);
			
			//On ecrit un objet dans le fichier par le filtre
			unFiltreDeRegularisation.writeObject(unDessin);
			
			//On ferme 
			unFiltreDeRegularisation.close();
		}
		
		//Ce catch est obligatoire et doit etre place devant le catch IOException
		catch(NotSerializableException e){System.out.println((String)e.getMessage());}
		
		// Ce catch est lui aussi obligatoire
		catch(IOException e){System.out.println((String)e.getMessage());}
				}
			}
		);
	 	
	 	
	 	
	 	
		// la fermeture de la fentre
        addWindowListener(new WindowAdapter(){
        public void windowClosing(WindowEvent w)
        {System.exit(0);}});}
	
	
	
	
//Les classes qui implementent ActionListener:

///// MENU /////
class New implements ActionListener{
         public void actionPerformed(ActionEvent e) {
     if(!(unDessin.v.isEmpty()))       unDessin.v.removeAllElements();
         unDessin.repaint();
        }
        }
            
class Fermer implements ActionListener{
         public void actionPerformed(ActionEvent e) {
         System.exit(0);
                     }
                 }

///// OPTION /////
class videplein implements ItemListener{                        
         public void itemStateChanged(ItemEvent e) {
             if(vp.getSelectedItem()=="VIDE")    unDessin.E=0;                         
             if(vp.getSelectedItem()=="PLEIN")  unDessin.E=1;          
                                }                       
                 }                      

//////////////////// COULEUR ////////////////////
class orange implements ActionListener{       
         public void actionPerformed(ActionEvent e) {       
            unDessin.C=Color.orange;
                    }       
                 } 
class noir implements ActionListener{       
         public void actionPerformed(ActionEvent e) {       
            unDessin.C=Color.black;
                    }       
                 }      

class rouge implements ActionListener{      
         public void actionPerformed(ActionEvent e) {       
            unDessin.C=Color.red;
                    }       
                     }      

class vert implements ActionListener{       
         public void actionPerformed(ActionEvent e) {       
            unDessin.C=Color.green;        
                     }      
                     }      

class bleu implements ActionListener{       
         public void actionPerformed(ActionEvent e) {       
         unDessin.C=Color.blue;        
                     }      
                         }      

class jaune implements ActionListener{      
         public void actionPerformed(ActionEvent e) {       
         unDessin.C=Color.yellow;
             }      
         }      
        
class rose implements ActionListener{               
         public void actionPerformed(ActionEvent e) {               
                unDessin.C=Color.pink;     
             }              
         }              

class magenta implements ActionListener{                
         public void actionPerformed(ActionEvent e) {       
            unDessin.C=Color.magenta;
             }              
         }              

//////////////////// PALETTE COULEUR ////////////////////
class Palett implements ActionListener{             
         public void actionPerformed(ActionEvent e) {       
            pl.setVisible(true);
             }              
         }              

//////////////////// FORME ////////////////////
class rect implements ActionListener{               
         public void actionPerformed(ActionEvent e) {
             unDessin.figure=1;}
             }          

class rectarr implements ActionListener{                      
         public void actionPerformed(ActionEvent e) {
                unDessin.figure=2;}
                    }                   

class ligne implements ActionListener{                     
         public void actionPerformed(ActionEvent e) {
                    unDessin.figure=3;}
                    }                   

class oval implements ActionListener{                      
         public void actionPerformed(ActionEvent e) {
                    unDessin.figure=4;}
                        }                   

class crayon implements ActionListener{                      
         public void actionPerformed(ActionEvent e) {
                     unDessin.figure=5;}
                         }                                             
class arc implements ActionListener{                        
         public void actionPerformed(ActionEvent e) {               
                 unDessin.figure=7;}

                     }
class efface implements ActionListener{                        
         public void actionPerformed(ActionEvent e) {               
                 unDessin.figure=8;}

                     }
class pipette implements ActionListener{                        
         public void actionPerformed(ActionEvent e) {               
                 unDessin.figure=9;}

                     }
class pinceau implements ActionListener{                        
         public void actionPerformed(ActionEvent e) {               
                 unDessin.figure=6;}

                     }
class texte implements ActionListener{                        
         public void actionPerformed(ActionEvent e) {               
                 unDessin.figure=10;
                 String unTexte =JOptionPane.showInputDialog("Entrez de quoi");
                 unDessin.Texte=unTexte;
                 }

                     }
                     
///// ABOUT /////
class auteurs implements ActionListener{                        
         public void actionPerformed(ActionEvent e) {               
                 Ap.setVisible(true);}

                     }

///// MAIN /////
public static void main(String[] arg)   {
             Paint javaPaint	=new Paint		();
             javaPaint			.setSize		(500,350);
             javaPaint			.setLocation	(150,150);
             javaPaint			.setVisible		(true);
             javaPaint			.setBackground	(Color.blue);
            }
}

/*******************************************************/
/****************** CLASSE DESSIN **********************/
/*******************************************************/
class Dessin extends Canvas implements MouseListener, MouseMotionListener, Serializable{
     private int x1,y1,x2,y2,x,y;
     public int figure=0;
     int E=0;
     Image m;
     Graphics g;
     Vector v=new Vector();
     Color C,temp;
     FIGURE r;
     public String Texte;
    
    
//Le constructeur : 
public Dessin(){

         resize(500,250);
         setBackground(Color.white);
         addMouseListener(this);
         addMouseMotionListener(this);
                 }
                 

public void update (Graphics g){
            paint(g);
}
public void paint(Graphics gr){

         m=createImage(size().width,size().height);
         g=m.getGraphics();

//Dessin de tout les lments du vecteur :
        
for(int i=0;i<v.size();i++){       
             r=(FIGURE)v.elementAt(i);
                g.setColor(r.couleur);

    switch(r.E){    //Vide ou plein:
        case 0:{    //Vide:
            switch(r.figure){
                     case 1://Rectangle
                        {
                        //-xy
                        if((r.x<r.width)&&(r.y<r.height))    g.drawRect(r.x,r.y,r.width-r.x,r.height-r.y);
                        //xy
                        if((r.x<r.width)&&(r.y>r.height))    g.drawRect(r.x,r.height,r.width-r.x,r.y-r.height);
                        //-x-y
                        if((r.x>r.width)&&(r.y<r.height))    g.drawRect(r.width,r.y,r.x-r.width,r.height-r.y);
                        //x-y
                        if((r.x>r.width)&&(r.y>r.height))    g.drawRect(r.width,r.height,r.x-r.width,r.y-r.height);
                        }   break;
            
                     case 2://Rectangle-Rond
                        {
                        if((r.x<r.width)&&(r.y<r.height))    g.drawRoundRect(r.x,r.y,r.width-r.x,r.height-r.y,r.width/5,r.height/5);
                        if((r.x<r.width)&&(r.y>r.height))    g.drawRoundRect(r.x,r.height,r.width-r.x,r.y-r.height,r.width/5,r.height/5);
                        if((r.x>r.width)&&(r.y<r.height))    g.drawRoundRect(r.width,r.y,r.x-r.width,r.height-r.y,r.width/5,r.height/5);
                        if((r.x>r.width)&&(r.y>r.height))    g.drawRoundRect(r.width,r.height,r.x-r.width,r.y-r.height,r.width/5,r.height/5);
                        }   break;
            
                case 3: g.drawLine(r.x,r.y,r.width,r.height);   break;
                case 4:
                     {
                     if((r.x<r.width)&&(r.y<r.height))      g.drawOval(r.x,r.y,r.width-r.x,r.height-r.y);
                     if((r.x<r.width)&&(r.y>r.height))      g.drawOval(r.x,r.height,r.width-r.x,r.y-r.height);
                     if((r.x>r.width)&&(r.y<r.height))      g.drawOval(r.width,r.y,r.x-r.width,r.height-r.y);
                     if((r.x>r.width)&&(r.y>r.height))      g.drawOval(r.width,r.height,r.x-r.width,r.y-r.height);
                     }  break;
                     
                //Crayon
                case 5: g.drawLine(r.x,r.y,r.width,r.height);break;
                case 6:g.fillOval(r.x,r.y,20,20);break;

                case 7:
                     {
                     if((r.x<r.width)&&(r.y<r.height))   g.drawArc(r.x,r.y,r.width-r.x,r.height-r.y,0,90);
                     if((r.x<r.width)&&(r.y>r.height))   g.drawArc(r.x,r.height,r.width-r.x,r.y-r.height,0,90);
                     if((r.x>r.width)&&(r.y<r.height))   g.drawArc(r.width,r.y,r.x-r.width,r.height-r.y,0,90);
                     if((r.x>r.width)&&(r.y>r.height))   g.drawArc(r.width,r.height,r.x-r.width,r.y-r.height,0,90);
                     }  break;
                case 8:temp=g.getColor();g.setColor(Color.white);g.fillOval(r.x,r.y,20,20);g.setColor(temp);break;
                case 9:break;
                case 10:r.setText(Texte);g.drawString(r.getText(),r.x,r.y);break;
                            }

                     }  break;
        case 1:{ //Plein:
            switch(r.figure){
                case 1:
                     {
                     if((r.x<r.width)&&(r.y<r.height))   g.fillRect(r.x,r.y,r.width-r.x,r.height-r.y);
                     if((r.x<r.width)&&(r.y>r.height))   g.fillRect(r.x,r.height,r.width-r.x,r.y-r.height);
                     if((r.x>r.width)&&(r.y<r.height))   g.fillRect(r.width,r.y,r.x-r.width,r.height-r.y);
                     if((r.x>r.width)&&(r.y>r.height))   g.fillRect(r.width,r.height,r.x-r.width,r.y-r.height);
                    }   break;

                case 2:
                     {
                     if((r.x<r.width)&&(r.y<r.height))   g.fillRoundRect(r.x,r.y,r.width-r.x,r.height-r.y,r.width/5,r.height/5);
                     if((r.x<r.width)&&(r.y>r.height))   g.fillRoundRect(r.x,r.height,r.width-r.x,r.y-r.height,r.width/5,r.height/5);
                     if((r.x>r.width)&&(r.y<r.height))   g.fillRoundRect(r.width,r.y,r.x-r.width,r.height-r.y,r.width/5,r.height/5);
                     if((r.x>r.width)&&(r.y>r.height))   g.fillRoundRect(r.width,r.height,r.x-r.width,r.y-r.height,r.width/5,r.height/5);
                     }  break;


                case 3: g.drawLine(r.x,r.y,r.width,r.height);   break;
                case 4:
                     {
                     if((r.x<r.width)&&(r.y<r.height))      g.fillOval(r.x,r.y,r.width-r.x,r.height-r.y);
                     if((r.x<r.width)&&(r.y>r.height))      g.fillOval(r.x,r.height,r.width-r.x,r.y-r.height);
                     if((r.x>r.width)&&(r.y<r.height))      g.fillOval(r.width,r.y,r.x-r.width,r.height-r.y);
                     if((r.x>r.width)&&(r.y>r.height))      g.fillOval(r.width,r.height,r.x-r.width,r.y-r.height);
                     }  break;


                case 5: g.drawLine(r.x,r.y,r.width,r.height);   break;
                case 6:g.fillOval(r.x,r.y,20,20);break;
                case 7:
                     {
                     if((r.x<r.width)&&(r.y<r.height))  g.fillArc(r.x,r.y,r.width-r.x,r.height-r.y,0,90);
                     if((r.x<r.width)&&(r.y>r.height))   g.fillArc(r.x,r.height,r.width-r.x,r.y-r.height,0,90);
                     if((r.x>r.width)&&(r.y<r.height))  g.fillArc(r.width,r.y,r.x-r.width,r.height-r.y,0,90);
                     if((r.x>r.width)&&(r.y>r.height))  g.fillArc(r.width,r.height,r.x-r.width,r.y-r.height,0,90);
                     }  break;
                case 8:temp=g.getColor();g.setColor(Color.white);g.fillOval(r.x,r.y,20,20);g.setColor(temp);break;
                case 9:break;
                case 10:r.setText(Texte);g.drawString(r.getText(),r.x,r.y);break;
                    }
                     }   break;

                     }
                }
            
        
g.setColor(C);
                
                
    switch(E){  //Vide ou plein:    
     case 0:{ //Vide:
             switch(figure){
                case 1:
                     {
                     if((x1<x2)&&(y1<y2))   g.drawRect(x1,y1,x2-x1,y2-y1);
                     if((x1<x2)&&(y1>y2))   g.drawRect(x1,y2,x2-x1,y1-y2);
                     if((x1>x2)&&(y1<y2))   g.drawRect(x2,y1,x1-x2,y2-y1);
                     if((x1>x2)&&(y1>y2))   g.drawRect(x2,y2,x1-x2,y1-y2);
                     }  break;
                case 2:
                     {
                     if((x1<x2)&&(y1<y2))   g.drawRoundRect(x1,y1,x2-x1,y2-y1,(x2-x1)/6,(y2-y1)/6);
                     if((x1<x2)&&(y1>y2))   g.drawRoundRect(x1,y2,x2-x1,y1-y2,(x2-x1)/6,(y1-y2)/6);
                     if((x1>x2)&&(y1<y2))   g.drawRoundRect(x2,y1,x1-x2,y2-y1,(x1-x2)/6,(y2-y1)/6);
                     if((x1>x2)&&(y1>y2))   g.drawRoundRect(x2,y2,x1-x2,y1-y2,(x1-x2)/6,(y1-y2)/6);
                     }  break;
                case 3:
                     {
                     setCursor(new Cursor(1));
                     g.drawLine(x1,y1,x2,y2);
                     }  break;
                case 4:
                     {
                     if((x1<x2)&&(y1<y2))    g.drawOval(x1,y1,x2-x1,y2-y1);
                     if((x1<x2)&&(y1>y2))    g.drawOval(x1,y2,x2-x1,y1-y2);
                     if((x1>x2)&&(y1<y2))    g.drawOval(x2,y1,x1-x2,y2-y1);
                     if((x1>x2)&&(y1>y2))    g.drawOval(x2,y2,x1-x2,y1-y2);
                     }  break;
                case 5:
                     {
                     setCursor(new Cursor(12));
                     g.drawLine(x1,y1,x2,y2);
                     }  break;
                case 6:g.fillOval(r.x,r.y,20,20);break;
                case 7:
                     {
                     if((x1<x2)&&(y1<y2))    g.drawArc(x1,y1,x2-x1,y2-y1,0,90);
                     if((x1<x2)&&(y1>y2))    g.drawArc(x1,y2,x2-x1,y1-y2,0,90);
                     if((x1>x2)&&(y1<y2))    g.drawArc(x2,y1,x1-x2,y2-y1,0,90);
                     if((x1>x2)&&(y1>y2))    g.drawArc(x2,y2,x1-x2,y1-y2,0,90);
                     }  break;
                case 8:temp=g.getColor();g.setColor(Color.white);g.fillOval(r.x,r.y,20,20);g.setColor(temp);break;
                case 9:break;
                     }
                     }  break;
        
     case 1:{ //Plein:
         switch(figure){
                 case 1:
                    {
                    if((x1<x2)&&(y1<y2))     g.fillRect(x1,y1,x2-x1,y2-y1);
                    if((x1<x2)&&(y1>y2))     g.fillRect(x1,y2,x2-x1,y1-y2);
                     if((x1>x2)&&(y1<y2))    g.fillRect(x2,y1,x1-x2,y2-y1);
                    if((x1>x2)&&(y1>y2))     g.fillRect(x2,y2,x1-x2,y1-y2);
                    }   break;
                 case 2:
                    {
                    if((x1<x2)&&(y1<y2))     g.fillRoundRect(x1,y1,x2-x1,y2-y1,(x2-x1)/6,(y2-y1)/6);
                    if((x1<x2)&&(y1>y2))     g.fillRoundRect(x1,y2,x2-x1,y1-y2,(x2-x1)/6,(y1-y2)/6);
                    if((x1>x2)&&(y1<y2))     g.fillRoundRect(x2,y1,x1-x2,y2-y1,(x1-x2)/6,(y2-y1)/6);
                    if((x1>x2)&&(y1>y2))     g.fillRoundRect(x2,y2,x1-x2,y1-y2,(x1-x2)/6,(y1-y2)/6);
                    }   break;
                 case 3:    g.drawLine(x1,y1,x2,y2);break;
                 case 4:
                    {
                    if((x1<x2)&&(y1<y2))     g.fillOval(x1,y1,x2-x1,y2-y1);
                    if((x1<x2)&&(y1>y2))     g.fillOval(x1,y2,x2-x1,y1-y2);
                    if((x1>x2)&&(y1<y2))     g.fillOval(x2,y1,x1-x2,y2-y1);
                    if((x1>x2)&&(y1>y2))     g.fillOval(x2,y2,x1-x2,y1-y2);
                    }   break;
                 case 5:    g.drawLine(x1,y1,x2,y2); break;
                 case 6:g.fillOval(r.x,r.y,20,20);break;
                 case 7:
                    {
                    if((x1<x2)&&(y1<y2))     g.fillArc(x1,y1,x2-x1,y2-y1,0,90);
                    if((x1<x2)&&(y1>y2))     g.fillArc(x1,y2,x2-x1,y1-y2,0,90);
                    if((x1>x2)&&(y1<y2))     g.fillArc(x2,y1,x1-x2,y2-y1,0,90);
                    if((x1>x2)&&(y1>y2))     g.fillArc(x2,y2,x1-x2,y1-y2,0,90);
                    }   break;
                 case 8:temp=g.getColor();g.setColor(Color.white);g.fillOval(r.x,r.y,20,20);g.setColor(temp);break;
                 case 9:break;
                    }
                    }   break;
                        
        
                }
                gr.drawImage(m,0,0,this);
        
   
    }
        
        
// Definition des mthodes de MouseListener et mouseMotionListener:     

    public void mousePressed(MouseEvent e) {
            e.consume();
            x1=e.getX();
            y1=e.getY();
            if(figure==5 || figure==8 || figure==6)   {x2=x1; y2=y1;}
            }
    public void mouseDragged(MouseEvent e) {
            e.consume();
            if(figure==5 || figure==8 || figure==6)   { x1=x2;     y1=y2;}
            x2=e.getX();
            y2=e.getY();
            if(figure==5 || figure==8 || figure==6)	v.addElement(new FIGURE(x1,y1,x2,y2,figure,C,E));
            repaint();
            }
    public void mouseReleased(MouseEvent e) {
            e.consume();
            x2=e.getX();
            y2=e.getY();
            if(figure==10){v.addElement(new FIGURE(x1,y1,x2,y2,figure,C,Texte));}
            else{v.addElement(new FIGURE(x1,y1,x2,y2,figure,C,E));}
            x2=x1;
            y2=y1;
            repaint();
    }
    public void mouseEntered(MouseEvent e){}
    public void mouseExited(MouseEvent e){}
    public void mouseMoved(MouseEvent e){}
    public void mouseClicked(MouseEvent e){}
}
/************************************************/
/**************** CLASSE FIGURE *****************/
/************************************************/
class FIGURE extends Rectangle implements Serializable{
            Color couleur;
    int figure;
    int E; //vide ou plein:
    String leTexte;
   
    public FIGURE(int x,int y,int w,int h,int f,Color c,int e){
       super(x,y,w,h);
       figure=f;
       couleur=c;
       E=e;
    }
    public FIGURE(int x,int y,int w,int h,int f,Color c,String t){
       super(x,y,w,h);
       figure=f;
       couleur=c;
       leTexte=t;
    }
    public void setText(String t){
    	leTexte=t;
    }
    public String getText(){return leTexte;}
}

/*************************************************/ 
/****************** A PROPOS *********************/
/*************************************************/
// La classe qui gere le Menu :Apropos:
class fen extends JDialog{
    JPanel pf1,pf2,pf3;
    JLabel text1,text2,text3;
    Font font;
    public fen(){
    super(new Frame(),"Les Auteurs",true);
    
            text1 = new JLabel("  JaVa Paint!  ");
            text2 = new JLabel ("TOUS DROITS RESERVES   : -21/01/2002- Auteur:  ENNOURE TAOUFIK");
            text3 = new JLabel("Remasteris par: GABRIEL GOSSELIN");
    getContentPane().setLayout(new BorderLayout());
    pf1=new JPanel();
    pf2=new JPanel();
    pf3=new JPanel();
    pf1.add(text1);
    pf2.add(text2);
    pf3.add(text3);
    getContentPane().add("North",pf1);
    getContentPane().add("Center",pf2);
    getContentPane().add("South",pf3);

        setLocation(180,50);
        
        
        addWindowListener(new WindowAdapter(){
                    public void windowClosing(WindowEvent w)    {setVisible(false);}

            });
            
        pack(); 
}

}

            

/*************************************************/ 
/**************** CLASSE PALETTE *****************/
/*************************************************/
//La classe qui gere la palette des couleurs:
class palette extends Dialog{
     int[]col=new int[3];   

    
    Color couleur=Color.black;
    Label l1;
    Canvas c;
    Panel p1;
    
    Label l2;
    Scrollbar s2;
    
    Label l3;
    Scrollbar s3;
    
    Label l4;
    Scrollbar s4;
    
Dessin target;
    
    Button ok;
    Button cancel;
    Panel panelbouton;

    Panel p;

public palette(Dessin T)
    {
    // TITRE
    super(new Frame(),"Palette De Couleurs",true);
    target=T;									// DESSIN
    
    p1 = new Panel		(new FlowLayout());		// PANEL
    c  = new Canvas		();						// CANEVAS
    l1 = new Label		("la couleur choisie:");// LABEL
    c.setBackground		(couleur);				// COULEUR
    c.setSize			(60, 30);				// DIMENSSION
    // AJOUT
    p1.add(l1);									// PANNEAU
    p1.add(c);									// CANEVAS
    
    // SCROLLBAR POUR LA COULEUR
    l2=new Label("Rouge");
    s2 = new Scrollbar(Scrollbar.HORIZONTAL, Color.black.getRed(), 1, 0, 255);
    l3=new Label("Vert");
    s3 = new Scrollbar(Scrollbar.HORIZONTAL, Color.black.getGreen(), 1, 0, 255);  
    l4=new Label("Bleu");
    s4 = new Scrollbar(Scrollbar.HORIZONTAL, Color.black.getBlue(), 1, 0, 255);
    
    // BOUTTONS
    ok =new Button("OK");						// OK
    cancel =new Button("Cancel");				// CANCEL
    
    // PANEL
    panelbouton =new Panel(new FlowLayout());	// PANEL
    
    // AJOUT
    panelbouton.add(ok);						// BOUTTON OK
    panelbouton.add(cancel);					// BOUTTON CANCEL
    
    // PANNEAU POUR LES SCROLLBAR
    p=new Panel(new GridLayout(3,2));			// PANNEAU
    p.setSize(60,20);							// DIMENSSION
    // AJOUT DU SCROLLBAR ET #
    p.add(s2);          p.add(l2);				// ROUGE
    p.add(s3);          p.add(l3);				// VERT
    p.add(s4);          p.add(l4);				// BLEU
    // LAYOUT DE LA FENTRE
    setLayout(new BorderLayout());
    add("North",p1);							// AFFICHAGE DE LA COULEUR
    add("Center",p);							// SCROLLBAR POUR LA COULEUR
    add("South",panelbouton);					// BOUTTONS DE VALIDATION
    
    s2.addAdjustmentListener(new AdjustmentListener() {
        public void adjustmentValueChanged(AdjustmentEvent e) {
        couleur = new Color(e.getValue(),couleur.getGreen(),couleur.getBlue());
        l2.setText("Rouge:" + e.getValue());
         deroulement();
        }
    });
    
    s3.addAdjustmentListener(new AdjustmentListener() {
        public void adjustmentValueChanged(AdjustmentEvent e) {
        couleur = new Color(couleur.getRed(), e.getValue(), couleur.getBlue());
        l3.setText("Vert:" + e.getValue());
         deroulement();
        }
    });
    
	s4.addAdjustmentListener(new AdjustmentListener() {
        public void adjustmentValueChanged(AdjustmentEvent e) {
        couleur = new Color(couleur.getRed(),couleur.getGreen(),e.getValue());
        l4.setText("Bleu:" + e.getValue());
         deroulement();
        }
    });
    
    // BOUTTON OK
    ok.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
        col[0]=s2.getValue(); col[1]=s3.getValue();
     col[2]=s4.getValue();
     target.C=new Color(col[0],col[1],col[2]);
        setVisible(false);
        
        }
    });
    
    // BOUTTON CANCEL
    cancel.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
        couleur = Color.black;
         setVisible(false);
        }
    });
    setLocation(200,50);
    pack();
    }

public void deroulement()   {
    
    c.setBackground(couleur);
    c.getGraphics().clearRect(0, 0,
    c.getSize().width, c.getSize().height);
    c.setBackground(couleur);
                                }
    
}
/***************************** LA FIN *****************************/  